scala.tools.nsc.backend.icode.GenICode.ICodePhase

# Context

###
Related Doc: package ICodePhase

#### class Context extends AnyRef

The Context class keeps information relative to the current state in code generation

Source
  GenICode.scala

Linear Supertypes
AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Context
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new Context(other: Context)

2. #### new Context()

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Context to any2stringadd[Context] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Context, B)

   Implicit information
     This member is added by an implicit conversion from Context to ArrowAssoc[Context] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### def Try(body: (Context) ⇒ Context, handlers: List[(Global.Symbol, Global.icodes.TypeKind, (Context) ⇒ Context)], finalizer: Global.Tree, tree: Global.Tree): Context

   Generate exception handlers for the body.

   Generate exception handlers for the body. Body is evaluated with a context where all the handlers are active. Handlers are evaluated in the 'outer' context.

   It returns the resulting context, with the same active handlers as before the call. Use it like:

   `ctx.Try( ctx => { ctx.bb.emit(...) // protected block }, (ThrowableClass, ctx => { ctx.bb.emit(...); // exception handler }), (AnotherExceptionClass, ctx => {... } ))`

   The resulting structure will look something like

   outer: // this 'useless' jump will be removed later, // for now it separates the try body's blocks from previous // code since the try body needs its own exception handlers JUMP body

   body: [ try body ] JUMP normalExit

   catch[i]: [ handler[i] body ] JUMP normalExit

   catchAll: STORE exception [ finally body ] THROW exception

   normalExit: [ finally body ]

   each catch[i] will cover body. catchAll will cover both body and each catch[i] Additional finally copies are created on the emission of every RETURN in the try body and exception handlers.

   This could result in unreachable code which has to be cleaned up later, e.g. if the try and all the exception handlers always end in RETURN then there will be no "normal" flow out of the try/catch/finally. Later reachability analysis will remove unreacahble code.

7. #### def addFinalizer(f: Global.Tree, ctx: Context): Context.this.type

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

9. #### var bb: Global.icodes.BasicBlock

   The current basic block.

10. #### var clazz: Global.icodes.IClass

    The current class.

11. #### var cleanups: List[Cleanup]

    The current monitors or finalizers, to be cleaned up upon `return`.

12. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

13. #### var currentExceptionHandlers: List[Global.icodes.ExceptionHandler]

    The exception handlers we are currently generating code for

14. #### var defdef: Global.DefDef

    Current method definition.

15. #### def dup: Context

    Clone the current context

16. #### def endHandler(): Unit

17. #### def ensuring(cond: (Context) ⇒ Boolean, msg: ⇒ Any): Context

    Implicit information
      This member is added by an implicit conversion from Context to Ensuring[Context] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: (Context) ⇒ Boolean): Context

    Implicit information
      This member is added by an implicit conversion from Context to Ensuring[Context] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def ensuring(cond: Boolean, msg: ⇒ Any): Context

    Implicit information
      This member is added by an implicit conversion from Context to Ensuring[Context] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

20. #### def ensuring(cond: Boolean): Context

    Implicit information
      This member is added by an implicit conversion from Context to Ensuring[Context] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

21. #### def enterMethod(m: Global.icodes.IMethod, d: Global.DefDef): Context

    Prepare a new context upon entry into a method.

22. #### def enterScope(): Unit

23. #### def enterSynchronized(monitor: Global.icodes.Local): Context.this.type

24. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

25. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

26. #### def exitScope(): Unit

27. #### def exitSynchronized(monitor: Global.icodes.Local): Context.this.type

28. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

29. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Context to StringFormat[Context] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

30. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

31. #### var handlerCount: Int

32. #### var handlers: List[Global.icodes.ExceptionHandler]

    current exception handlers

33. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

34. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

35. #### var labels: HashMap[Global.Symbol, Label]

    Map from label symbols to label objects.

36. #### def loadException(ctx: Context, exh: Global.icodes.ExceptionHandler, pos: Global.Position): Unit

37. #### def makeLocal(pos: Global.Position, tpe: Global.Type, name: String): Global.icodes.Local

    Make a fresh local variable.

    Make a fresh local variable. It ensures the 'name' is unique.

38. #### var method: Global.icodes.IMethod

    The current method.

39. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

40. #### def newBlock(): Context

    Return a new context for a new basic block.

41. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

42. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

43. #### var packg: Global.Name

    The current package.

44. #### var scope: Scope

    The current local variable scope.

45. #### def setBasicBlock(b: Global.icodes.BasicBlock): Context.this.type

46. #### def setClass(c: Global.icodes.IClass): Context.this.type

47. #### def setMethod(m: Global.icodes.IMethod): Context.this.type

48. #### def setPackage(p: Global.Name): Context.this.type

49. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

50. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      Context → AnyRef → Any

51. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

52. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

53. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

54. #### def →[B](y: B): (Context, B)

    Implicit information
      This member is added by an implicit conversion from Context to ArrowAssoc[Context] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Context to any2stringadd[Context]

### Inherited by implicit conversion StringFormat from Context to StringFormat[Context]

### Inherited by implicit conversion Ensuring from Context to Ensuring[Context]

### Inherited by implicit conversion ArrowAssoc from Context to ArrowAssoc[Context]

### Ungrouped